/******* Main OPS LOOP ************/

/*****************************************************************
	Initialization of OPS
*****************************************************************/
void OpsInit (bit OpsMs)
{
	size2 const char *point = MenuTxt[0].pt1;
	char i,CoefP1,CoefP2,CoefP3,CoefP4,st;
	uns16 calci;
	uns16 calc;
	uns24 calc24;

	ErrorCode = 0;
	stport = 0;
	// first set current coef
	if (Inputs == 3) Inputs = 2;	
	switch (Inputs)
	{
		case 1:
		{
			CoefP1=1;
			CoefP2=1;
			CoefP3=1;
			CoefP4=1;
			break;
		}
		case 2:
		{
			CoefP1=2;
			CoefP2=2;
			CoefP3=2;
			CoefP4=2;
			break;
		}
		case 4:
		{
			CoefP1=4;
			CoefP2=4;
			CoefP3=4;
			CoefP4=4;
			break;
		}			
	}
	// now set pots to default for checking presence of bat		
	if ((OpsMode == 1) || (OpsMode == 2))		//test capacity or stock
	{
		TxtDisp(17,0,point,210,1,0,0);
		LCDK_DrawLine(0,12,127, 12);
		LCDK_DrawLine(0,13,127,13);
		LCDK_DrawLine(11,14,11,51);
		LCDK_DrawLine(45,14,45,51);
		LCDK_DrawLine(86,14,86,51);
		LCDK_DrawLine(0,52,127,52);
		LCDK_DrawLine(0,53,127,53);
		if (OpsMode == 1)
		txt[9] = 'C';
		if (OpsMode == 2)
		txt[9] = 'S';
		un = Elements + 0x30;
		txt[10] = un;
		txt[11] = 'S';
		txt[12] = 0;
		LCDK_PrintLine(1,0,7,0);	
		txt[0] = 'T';
		txt[1] = ':';
		txt[2] = 0;
		LCDK_PrintLine(Font6x8,13, 7,0);
		calci = Current / 4;
		// pot1
		calc = calci * CoefP1;		//val 0-2000
		for (i = 0;i!=4;i++)
		{
			Curr[i] = calc;		//no difference in each port current at this stage
			VPot[i] = 2;
			LoadPot(i);
		}	
		tempo (250,1);		// stabilize first
		NextANP = 0;
		SlvCntr = 0;
		ADCModule (1);		// one full measure
		while (NextANP !=0) ADCModule(0);
		DispCtr = 0;
	// Disable inactive entries, check for battery presence
// comment next line for test
		CheckActive();			
//	CheckElements();	// check if number of elements is coherent	
		if (ErrorCode !=0)
		{
			ErHdlOps(ErrorCode);
			OpsComplete = 1;
			SW1 = 1; 
		}	
		else
		{
			for (i=0;i!=4;i++)
			{
				MsCtr[i] = 1999;
				st = State[i];
				if (st.7 != 0)
				{
					calci = Curr[i];
					calc24= (uns24)calci * 1000;
					calc24 = calc24 / KAmp[i];
					calc = calc24;
					calci /= 10;
					VPot[i] = (char)calci;		// approx i val
					ADCCurr[i] = calc;
				}
				else 
				{
					Curr[i] = 0;
					VPot[i] = 0;
					ADCCurr[i] = 0;
				}
				LoadPot(i);	
			}	
			// set relays
			switch (Inputs)
			{
				case 1:
				{
					TxBuf[0]='1';
					TxBuf[1]=0b111;
					if (RCIF) i=RCREG1;
					TxData();
					RcvData('A');
					break;
				}
				case 2:
				{
					TxBuf[0]='1';
					TxBuf[1]=0b101;
					if (RCIF) i=RCREG1;
					TxData();
					RcvData('A');
					break;
				}
				case 4:
				{
					TxBuf[0]='1';
					TxBuf[1]=0b000;
					if (RCIF) i=RCREG1;
					TxData();
					RcvData('A');
					break;
				}			
			}	
			CurCumul[0] = 0;
			CurCumul[1] = 0;
			CurCumul[2] = 0;
			CurCumul[3] = 0;
			sec =0;
			min = 0;
			hour = 0;
			ATmr = 0;
			token[0] = 0;
			token[1] = 0;
			token[2] = 0;
			token[3] = 0;
			if (OpsMode == 1)		//decharge
			{
				TargetV = (uns16)Elements * 3000;	//3.0v
			}
			if (OpsMode == 2) 	// Storage
			{
				TargetV = (uns16)Elements * 3850;	//3.8v
			}					
		}
	}
	// ****************************************************************	
	if (OpsMode == 3)		// balance elements
	{
		TargetV = 3400;	//3.4v, close to full discharge
		TxtDisp(17,0,point,210,1,0,0);
		LCDK_DrawLine(0,12,127, 12);
		LCDK_DrawLine(0,13,127,13);
		LCDK_DrawLine(11,14,11,51);
		LCDK_DrawLine(45,14,45,51);
		LCDK_DrawLine(86,14,86,51);
		LCDK_DrawLine(0,52,127,52);
		LCDK_DrawLine(0,53,127,53);
		TxBuf[0]='1';		// sets all relays to off
		TxBuf[1]=0b0;		// each port separated
		if (RCIF) i=RCREG1;
		TxData();
		RcvData('A');
		tempo(51,1);
	}	
	
	// *****************************************************************					
	if (OpsMode == 4)		//calibrate
	{
		NextANP = 0;
		ADCModule (1);		// one full measure
		for (i = 0;i!=4;i++) State[i] = 0;
		CheckActive();
		if (ErrorCode != 1)
		{
			if (MenuItem == 40)		//voltage
			{
				TxtDisp(14,0,point,250,1,0,0);
				TxtDisp(16,5,point,278,1,0,0);
				TxtDisp(18,6,point,294,1,1,0);
				TxBuf[0]='1';		// sets all relays to on
				TxBuf[1]=0b111;		// one measure for the 4 ports
				if (RCIF) i=RCREG1;
				TxData();
				RcvData('A');
				tempo(51,1);
				
/*				TxBuf[0]='1';		// sets all relays to on
				TxBuf[1]=0b011;		// one measure for the 4 ports
				if (RCIF) i=RCREG1;
				TxData();
				RcvData('A');
				tempo(50,1);
				TxBuf[0]='1';		// sets all relays to on
				TxBuf[1]=0b111;		// one measure for the 4 ports
				if (RCIF) i=RCREG1;
				TxData();
				RcvData('A');
*/						
				upcntr = 100;
				RselSWchg = 0;
				VoltStep = 0;
				OldRot = 100;
				RealVolt = 0;
				SW3 = 0;
				SW2 = 0;		
			}
			if (MenuItem == 41)	// current
			{
				TxtDisp(14,0,point,264,1,0,0);
				TxtDisp(11,4,point,312,1,0,0);
				TxtDisp(11,6,point,323,1,0,0);
				LCDK_DrawLine(0,12,127, 12);
				SW3 = 0;
				SW2 = 0;
				TogglePotMes = 0;
				upcntr = 100;
				RselSWchg = 0;
				VoltStep = 0;
				RealVolt = 0;
				OldRot = 100;
				if (Inputs > 4) Inputs = 1;
				for (i=0;i!=4;i++) VPot[i] = 0;
				TxBuf[0]='1';		// sets all relays to off
				TxBuf[1]=0b0;		
				if (RCIF) i=RCREG1;
				TxData();
				RcvData('A');
			}
			if (MenuItem == 43)	// pot 
			{
				TxtDisp(14,0,point,380,1,0,0);
				LCDK_DrawLine(0,12,127, 12);
				TxtDisp(9,5,point,394,1,0,0);
				AjTmr = 5;
				un = 0x31;
				dispval (0,3,1,0,Font6x8);
				SW3 = 0;
				SW2 = 0;
				upcntr = 0;
				OldRot = 0;
				for (i = 0;i!=4;i++)
				{
					Curr[i] = Current;
				}
				State[0] = 0x81;
				State[1] = 0;
				State[2] = 0;
				State[3] = 0;	
				tempo(50,1);
				TxBuf[0]='1';		// sets all relays to on
				TxBuf[1]=0b111;		// one measure for the 4 ports
				if (RCIF) i=RCREG1;
				TxData();
				RcvData('A');				
			}
		}
		else
		{
			ErHdlOps(ErrorCode);
			OpsComplete = 1;
			SW1 = 1; 
		}								
	}
	if (OpsMode == 5)
	{
		LCDK_Cls(0x00);
		TxtDisp(7,1,point,413,1,0,0);
		TxtDisp(7,2,point,420,1,0,0);
	}	
		OpsStart = 0;		// init completed	
		OpsComplete = 0; 
		DispCtr = 0;
		
}	
