/* Processor accessory for relays */

#include "int16Cxx.h"
#include "DischrgSlv.h"

#pragma origin 4
interrupt intsrvc (void)

{
	int_save_registers	//auto saved by this pic, but clears PCLATH 
//	PCLATH = 0;
// ***** get analog values

	if (ADIF)		
	{
		ADIF = 0;
		ADRes.high8= ADRESH;
		ADRes.low8 = ADRESL;
		switch (NextANP)
		{
			case 0:
			{
				Bat1 = ADRes;
				break;
			}
			case 1:
			{
				Bat2 = ADRes;
				break;
			}		
			case 2:
			{
				Bat3 = ADRes;
				break;
			}
			case 3:
			{
				Bat4 = ADRes;
				break;
			}
			case 4:
			{
				TempADC	= ADRes;
				SlvState.3 = 1;
				break;
			}	
		}

	}
	
// ***** real time 1 ms clock		
	if (TMR2IF == 1)	
	{
		msflg = 1;
		TMR2IF = 0;
		cntms ++;
		if (cntms == 1000)
		{
			NbrLoopL = CtrLoopL;
			NbrLoopH = CtrLoopH;
			CtrLoopL = 0;
			CtrLoopH = 0;
			cntms = 0;
			secflg = 1;
		}	
// tempo 
		if (timer1 == 1)
		{
			tempoms--;
			if (tempoms == 0)
			{
				timer1 = 0;
			}
		}
	}

// ***** SRL data rcvd 

	if (RCIF == 1)  
	{
		RData = RCREG;
		if (NewMsg == 1)
		{
			if (RData == 0x55)	//start of frame
			{
				BufPtrRx = 0;
				NewMsg = 0;
			}
		}
		else
		{
			if (MsgComplete == 0)
			{
				RxBuf[BufPtrRx] = RData;
				BufPtrRx++;
				if (BufPtrRx == 5)	// all msgs = 5 char, 00 must be added to complete 
				{
					MsgComplete = 1;
					NewMsg = 1;
				}
			}
			// else previous data not processed so block ignored	
		}		
	}
	int_restore_registers		//only for completness, no code generated
}   // end interupt


void tempo (uns16 durationms,bit locked)		// max 65 sec but no validity check on param
{
	tempoms = durationms + 1; 
	timer1 = 1;
	if (locked)
	while (timer1);
} 


void TxData(void)
{
	char i;

	while (TXIF != 1);
	TXREG = 0xAA;
	for (i=0; i!=5;i++)
	{
		while (TXIF != 1);
		TXREG = TxBuf[i];
	}
	for (i=0;i!=5;i++)		//prepare pading of 0's for next tx
	{
		TxBuf[i] = 0;
	}
	TxDataFlg = 0;			
}	
#pragma codepage 0
void ProcCmd (void)
{
	char i,j;
	// poll msgcomplete
	if (MsgComplete == 1)
	{
		i = RxBuf[0];	// command code
		// here process rcvd datas
		switch (i)
		{
			case 0x31:		// action relay
			{
				j = RxBuf[1];
				Rel1 = j.0;
				Rel2 = j.1;
				Rel3 = j.2;
				TxDataFlg = 1;
				TxBuf[0] = 'A';
				TxData();
				break;
			}
			case 2:		// tx Val Bat 1
			{
				TxBuf[0] = 2;
				TxBuf[1] = Bat1.high8;
				TxBuf[2] = Bat1.low8;
				TxDataFlg = 1;
				TxData();
				break;
			}		
			case 3:		// tx Val Bat 2
			{
				TxBuf[0] = 3;
				TxBuf[1] = Bat2.high8;
				TxBuf[2] = Bat2.low8;
				TxDataFlg = 1;
				TxData();
				break;
			}		
			case 4:
			{
				TxBuf[0] = 4;
				TxBuf[1] = Bat3.high8;
				TxBuf[2] = Bat3.low8;
				TxDataFlg = 1;
				TxData();
				break;
			}		
			case 5:		// tx Val Bat 3
			{
				TxBuf[0] = 5;
				TxBuf[1] = Bat4.high8;
				TxBuf[2] = Bat4.low8;
				TxDataFlg = 1;
				TxData();
				break;
			}	
			case 6:		// tx Val Temp, must be valid
			{
				TxBuf[0] = 6;
				TxBuf[1] = TempADC.high8;
				TxBuf[2] = TempADC.low8;
				TxDataFlg = 1;
				TxData();
				break;	
			}				
			case 7:		// send status
			{
				TxBuf[0] = 7;
				j = PORTC;
				j &= 0x0F;
				j *= 16;
				SlvState &= 0x0F;
				SlvState |= j;
				TxBuf[1] = SlvState;
				TxBuf[2] = NbrLoopH;
				TxBuf[3] = NbrLoopL.high8;
				TxBuf[4] = NbrLoopL.low8;
				TxDataFlg = 1;
				TxData();
				SlvState = 1;	//will be updated again after all data collection done
				break;
			}	
			case 8:
			{
				TxBuf[0] = 8;
				TxBuf[1] = Temp.high8;
				TxBuf[2] = Temp.low8;
				TxBuf[3] = TMR1H;
				TxBuf[4] = TMR1L;
				TxDataFlg = 1;
				TxData();
				break;
			}

			case 9:
			{	
				TxBuf[0] = 9;
				CoefA.high8 = RxBuf[1];
				CoefA.mid8 = RxBuf[2];
				CoefA.low8 = RxBuf[3];
				TxDataFlg = 1;
				TxData();
				break;
			}
			case 10:
			{	
				TxBuf[0] = 10;
				CoefB.high8 = RxBuf[1];
				CoefB.mid8 = RxBuf[2];
				CoefB.low8 = RxBuf[3];
				TxDataFlg = 1;
				TxData();
				break;
			}			
			case 11:
			{	
				TxBuf[0] = 11;
				CoefC.high8 = RxBuf[1];
				CoefC.mid8 = RxBuf[2];
				CoefC.low8 = RxBuf[3];
				TxDataFlg = 1;
				TxData();
				break;
			}												
		}
		// then open reception again
		for (i=0;i!=5;i++)		//prepare pading of 0's for next tx
		{
			RxBuf[i] = 0;
		}
		MsgComplete = 0;
	}	
}	

#pragma codepage 0
void ProcADC(void)
{
	char i;
	
	while(GO != 0);
		{
	NextANP++;
	if (NextANP == 5)
	{
		NextANP= 0;
		SlvState.2 = 1;
	}
	if (NextANP == 4) 	ADCON1 = 0b11010000;
	else 	ADCON1 = 0b11010011;
	i = NextANP * 4;
	i = i|0b00000001;
	ADCON0 = i;		// prepare conversion
	for (i=0;i!=10;i++);	//acquisition time approx 5us
	GO = 1;			// start ADC, interrupt handels result	
	}
}	

void MainLoop(void)
{
	char i,j;
	CtrLoopL++;
	if (Zero_) CtrLoopH++;
	ProcCmd();
	ProcADC();
	if (OpsMS)
	{
		tmradc++;
		if (tmradc == 10)		//200 measures per second
		{
			ProcADC();
			tmradc = 0;
	}	
		ctr++;
		if (ctr == 1001)		//1 conversion per second
		{
			ctr = 0;
			CalcDegC();
		}	
	}
}

#pragma codepage 0
void Init()
{
	OSCCON = 0b01111011;	// 16mhz
	OSCTUNE = 0;
	PCON = 0;
	INTCON = 0;		//  disable all interrupts /
	STATUS = 0;
	// init i/o ports
	LATA = 0;
	LATC = 0;  
	TRISA = bin(111111);
	TRISC = bin(11100001);
	OPTION_REG = 0b00000100;		//tmr0 presc 32
	// init periph interrupts
	PIE1 = bin(00000000); // disabled int  
	PIR1 = 0;
	// init ram to 0
	clearRAM();
	// config ad converter
	WPUA = 0;
	WPUC = 0b1110000;
	ADCON0 = 0b00000001;		// adc on 
	ADCON1 = 0b11010011;		// fosc/16/right justif, ref = intrn vref,
	ANSELA = 0b00010111;		// PORTA0-2,4 are analog
	ANSELC = 0b00000001;		// PORTC.0 analog
	FVRCON = 0b10000011;		//vref = 4.096V
	ADIE = 1;					//interrupt mode
	// init USART 115.2 Kbps / 8 bits
	//config USART
	TXSTA = 0b00100100;
	RCSTA = 0b10010000;
	BAUDCON = 0b00001000;
	SPBRGL = (char)BAUDGEN;
	SPBRGH = 0;
	RCIE = 1;					//receive in interrupt mode
	// config timer2, real time clk 1ms
	T2CON = 0b00000110;			//no postscaler, /16 prescaler
	PR2 = 249;					//for 1ms period
	TMR2IE = 1;					//interrupt each ms
	// config timer1, performance measure
	T1CON = 0b00000000;			//instr clk,presc 1,osc off,no sync, tmr off
	T1GCON = 0b00000000;			//no gate control
	TMR1IE = 0;					//no interrupt
	//Turn on interrupts
	PEIE = 1;
	GIE = 1;
}
void InitVar (void)
{
	NewMsg = 1;
	MsgComplete = 0;
	SlvState = 0;
	TxDataFlg = 0;
	CoefA = CA;
	CoefB = CB;
	CoefC = CC;
}

#pragma codepage 0
		
void main (void)
{
	STKPTR = 0;
	OSCCON = 0b01101010;	// 4MHz intnl oscilator
	OSCSTAT = 1;
	ADCON0 = 0;		// All analog ports as digital
	TRISA.5 = 1;
	if (PORTA.5 == 0)
	{
#asm
	MOVLP 0x18
	call bootprocess
	MOVLP 0 
#endasm
	}
	Init();
	InitVar();
	//	startup sequence
	tempo (100,1);
	Rel1 = 1;
	tempo (200,1);
	Rel2 = 1;
	tempo (200,1);
	Rel3 = 1;
	tempo (200,1);
	SlvState = 1;	
	while (1)
	{
		if (msflg == 1)
		{
			OpsMS = 1;
			msflg = 0;
		}	
		MainLoop();
		OpsMS =0;
	}	
}


#pragma codepage 1


#include "MATH24F.H"
#include "MATH24LB.H"

#pragma codepage 1
		
void CalcDegC (void)
{
	#pragma rambank 1

	float24 calc,calc1,calc2,ValCTN;

	// process value of temperature
	// first calculate value of voltage in mV
	TMR1H =0;
	TMR1L = 0;
	TMR1ON = 1;
	calc = TempADC; 
	calc1 = calc/1023;		// convert to  0...0.999
	
	// then value of resitor in ohms : R = (Vs * R1) / (Ve - Vs)
	calc2 = 5 * calc1;		// calc2 = vs  0..4.096v
	calc1 = calc2 * 18000;		// Vs * r1  r1 = 18K
	calc2 = 5.000 - calc2; 		//ve - vs
	ValCTN = calc1 / calc2;		// val r ctn
	// apply formula of SteinHart-Hart
	calc1 = log(ValCTN);	//log R
	calc = CoefC * calc1;	//+ (C *(log R)^3)
	calc = calc * calc1;
	calc = calc * calc1;
	calc2 = CoefB * calc1;	//+ (B * log R)
	calc += calc2;
	calc += CoefA;			//+A
	calc = 1/calc;			// 1/T completes formula 
	calc -= 273.15;			// convert deg K to deg C
	//then convert to integer and assign value for return
	Temp = calc;
	TMR1ON = 0;
}


#pragma codepage 3
#pragma origin 0x1800

/**********************************************************
		RS232 SERIAL BOOTLOADER
 
 >>>>>>>>>>>>>>>>>>> SPECIFIC 16F EXTENDED SERIES ><<<<<<<<<	
  - All polled, no interrupt is used in this soft.
 - All parameters must be set in the corresponding .h file.
 
 ===> after compil copy resulting asm into bo.asm.
 	  then recompile in assembly after replacement 
 	  of CALL to user soft by a GOTO usermain 
************************************************************/

// Clocking
#define b_CPUCLK					4L	// in Mhz
#define b_CYCLK					CPUCLK / 4000L	// Instruction cycle (cpu div by 4)

// process value of USART BRG VALUE, BRGH = 1, BRG16 = 1
#define b_BAUDR			57600L			// value of baud rate needed
#define b_CONSTBR1		b_CPUCLK * 1000000L
#define b_CONSTBR2		b_CONSTBR1 / 4
#define b_CONSTBR3		b_CONSTBR2 / b_BAUDR
#define b_BAUDGEN		b_CONSTBR3 - 1

#if (b_BAUDGEN) > (255)
	#error BootLD Baud rate value not possible with BRDH=1  
#endif
/* **************** FLASH PROGRAM CAPACITY ***************/
// capacity of pgm memory in bytes (2 times number of 14bits words)
// 16 for 8k pgm words
#define FLASHCAPACITY 250		// ex 16 k for 16f876

/********************************************
		GLOBAL VARIABLES
********************************************/
#pragma rambank 3
bit boot_OK, boot_Verif;
char rxdata, bi, boot_tp;
// dump values sent to pc in case or error
char dmpadrh,dmpadrl,dmpdathrd,dmpdatlrd,dmpdathwr,dmpdatlwr;
#pragma rambank 4
char boot_bufflash[64];
#pragma rambank 3

/* **************** FLASH PROGRAM CAPACITY ***************/
// capacity of pgm memory in bytes (2 times number of 14bits words)
// 16 for 8k pgm words
#define FLASHCAPACITY 250		// ex 16 k for 16f876

/********************************************
		HARDWARE DEFINITIONS
********************************************/
// Define the switch port that will trigger bootloading
// switch activation must be 0 if switch makes 0 when pressed
// otherwise must be 1
#define SWITCH PORTA.5
#define TrisSw TRISA.5
#define SwitchActivation 0

// If a led is available for status info, define it here
//#define LED LATA.4
//#define TrisLed TRISA.4 = 0
//#define LEDON 1;
//#define LEDOFF 0;


/*------------- End Interrupts services --------------*/

/********************************************************
     BOOTLOADER ROUTINES
 **********************************************************/


/* ********** FLASH WRITE P16F*********** */

#pragma rambank 3

void bootprocess (void)
{
// *** main bootloader

	char rcvdata, i, j, BCC; 
	uns16 boot_fadr,btloop;
	char tp;
	bit OutRng;
	char kflash;
	
	bInitialize();
	GIE = 0;		// no interrupt, polling only
//  host synch
	bi = 0;
	OutRng = 0;
	boot_tp=0;
	kflash = FLASHCAPACITY / 2;
	while (bi == 0)
	{
				rxdata = boot_waitsrl();
		if (rxdata == 'R')
		{
			nop();
			nop();
			rxdata = boot_waitsrl();

			if (rxdata == 'M')
			{
				nop();
				nop();
				rxdata = boot_waitsrl();
				if (rxdata == 'b')
				{
					nop();
					nop();
					rxdata = boot_waitsrl();
					if (rxdata == 't')
					{
//						LED = LEDOFF;
						boot_outsrl ('b');			// Device reply with c to complete handshake
						boot_outsrl ('t');
						boot_outsrl (FLASHCAPACITY);
						bi = 1;
					}	
				}
			}
		} 
	}

// tfr data 
	boot_fadr = 0;

// transfer format is :
// 27 as sart of block
// address high, address low, in hex.
// then 64 bytes follows, then check caracter
// When address is 0xff00: stop

	while (boot_fadr != 0xFF00)	// must complete with address FF00 to stop tfr
	{
		rxdata = boot_waitsrl();
		while (rxdata != 27)		// start of block 
		{
			if (rxdata == 28)	// verif loop
			{
				if (verif (boot_fadr) == 1)
				{
					boot_outsrl (6);
				}
				else
				{
					boot_outsrl(8);		// for test, must be 8
				}		
			}
			rxdata = boot_waitsrl();
		}
		rcvdata = boot_waitsrl();
		BCC = rcvdata;
		boot_fadr.high8 = rcvdata;
		rcvdata = boot_waitsrl();
		BCC += rcvdata;
		boot_fadr.low8 = rcvdata;
		if (boot_fadr == 0xFF00) break;
		for (i = 0;i!=64;i++)
		{
			rcvdata = boot_waitsrl();
			BCC += rcvdata;
			boot_bufflash[i] = rcvdata;
		}
		rcvdata = boot_waitsrl();	// BCC caracter
		if (rcvdata == BCC)  
		{
			boot_OK=1;
			if (OutRng == 0)
			{		
				boot_writeflash (boot_fadr);
				if (boot_OK == 1)
				{
					boot_outsrl (6);		// check is ok, reply ack
				}
				else
				{
					boot_outsrl (8);		// reply 8 for error write
					boot_outsrl (dmpadrh);
					boot_outsrl(dmpadrl);
					boot_outsrl(dmpdathrd);
					boot_outsrl(dmpdatlrd);
					boot_outsrl(dmpdathwr);
					boot_outsrl(dmpdatlwr);

				}
			}
			else 
			{
				boot_outsrl(9);
			}			
	
		}	
		else
		{
				boot_outsrl (7);	// reply nack, comm error
		}
	}
}

void boot_writeflash (uns16 fadr) // 64 bytes at once in bufflash
 {
	char i,j,k,l,m,n,pointr;
	uns16 svfadr;
	uns16 locadr;
	
	svfadr = fadr;
	locadr = fadr;
	boot_OK = 1;
	GIE = 0;		// should be already at 0, for standardizi	
	EEIE = 0;
	if (fadr < 0x1800)	// protect booloader zone
	{
		// *** first erase block
		EEADRH = locadr.high8;
		EEADRL = locadr.low8;
		EEIF = 0;
		CFGS = 0;
		EEPGD = 1;
		FREE = 1;
		WREN = 1;
		EECON2 = 0x55;
		EECON2 = 0xAA;
		WR = 1;
		nop();
		nop();
		FREE = 0;
		
		//  ***  then write data
		EEADRH = locadr.high8;
		EEADRL = locadr.low8;
		EEPGD = 1;
		CFGS = 0;
		WREN = 1;
		LWLO = 1;	// select latches
		EEIF =0;
		// write latches loop
		for (k = 0; k != 32; k++)
		{
			EEIF = 0;
			svfadr = locadr + k;
			pointr = k * 2;
			boot_bufflash[pointr+1] &= 0x3F;
			EEDATL = boot_bufflash[pointr];
			EEDATH = boot_bufflash[pointr+1];
			EECON2 = 0x55;
			EECON2 = 0xAA;
			WR = 1;
			nop();
			nop();
			EEADRL++;
		}
			// write flash now
		EEIF = 0;
		LWLO = 0;		// select flash
		EEADRL = locadr.low8;
		EEDATL = boot_bufflash[0];
		EEDATH = boot_bufflash[1];		
		EECON2 = 0x55;
		EECON2 = 0xAA;
		WR = 1;
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		nop();
		WREN = 0;
//		LED = !LED;
	}
	else boot_OK = 1;
}

bit verif (uns16 fadr)	
{
	char i,j,k,l,m,n,pointr;
	uns16 svfadr;
	uns16 locadr;
	
	boot_OK = 1;
// Method 2 read flash inprogramming mode
	if (fadr < 0x1800)	// ignore booloader zone
	{
		EEIF = 0;
		CFGS = 0;
		EEPGD = 1;
		for (n = 0; n != 32; n++)
		{
			svfadr = fadr + n;
			EEIF = 0;
			CFGS = 0;
			EEPGD = 1;
			EEADRL = svfadr.low8;
			EEADRH = svfadr.high8;
			pointr = n * 2;		
			RD = 1;
			nop();
			nop();
			nop();
			nop();
			k = EEDATL;
			j = EEDATH;
			j = j & 0x3F;
			l = boot_bufflash[pointr] & 0x3F;
			m = boot_bufflash[pointr+1];
			if (j !=l)	boot_OK = 0;
			if (k != m) boot_OK = 0;
		}
	}
	return boot_OK;
}
	
#pragma rambank 3
//  *** serial port routines
void boot_outsrl (char outcar)
	{
	while (TRMT == 0);
	TXREG = outcar;
	}

char boot_waitsrl (void)
{
while (RCIF == 0)
	{nop();
	nop();
	}
return RCREG;
}


void bInitialize(void)
{
	INTCON = 0;		//  disable all interrupts /
	STATUS = 0;
	PORTA = 0; 
	PORTC = 0;  
	TRISA = bin(111111);
	TRISC = bin(11111111);

// init periph interrupts 
	PIE1 = bin(00000000); // disabled int adc, usart, all polled
	PIR1 = 0;
	GIE = 0;			// no interrupt, polling hrdw
	clearRAM();
// init USART 19.2 Kbps / 8 bits
	//config USART
	TXSTA = 0b00100110;
	RCSTA = 0b10010000;
	BAUDCON = 0b00001000;
	SPBRGL = b_BAUDGEN;
	SPBRGH = 0;
	#if (b_BAUDGEN) > (255)
	SPBRGH = b_BAUDGEN / 256;
	#endif
	TRISC.4 = 1;
	TRISC.5 = 1;
	nop();
	bi = RCREG;		// dummy read to clear buffer
	nop();
	bi = RCREG;
}	


/************* RESET ENTRY POINT **************
void main( void)
{

	ADCON1 = 0x07;
	ANSELA = 0;
	ANSELC = 0;
// next line not needed, just in case wrong manip made on previous lines
	TrisSw = 1;		// input of course	
// test if switch pressed, otherwise jump to user code
	if (SWITCH == SwitchActivation)
	{
		Initialize();
#ifdef LED
		LED = LEDON;
#endif
		bootprocess();
	}
// if switch not pressed goto user startup

// CC5X does not allow a goto here below
// only way to change to GOTO is to use assembler later



}*/
	