/*  h FILE FOR DISCHARGE SLAVE */

#pragma config reg1 = 0x09C4
#pragma config reg2 = 0x3EFF
/* config
word 1: 0b00 1001 1100 0100 -0x09C4
b13	FCMEN = 0
b12 IESO = 0
b11 -CLKOUTEN = 1
b10-9 BOREN = 00
b8 -CPD = 1
b7 -CP = 1
b6 MCLRE = 1
b5 PWRTE = 0
b4-3 WDTE = 01
b2-0 FOSC = 100

word 2: 0b11 1110 1111 1111	-0x3EFF
b13 LVP = 1
b12 -DEBUG = 1
b11 unused = 1
b10 BORV = 1
b9 STVREN = 1
b8 PLLEN = 0
b7-5 unused  = 1
b4 reserved = 1
b3-2 unused = 1
b1-0 WRT = 11

*/
// Clocking
#define CPUCLK					16	// in Mhz
#define CYCLK					CPUCLK / 4L	// Instruction cycle (cpu div by 4)


// process value of USART BRG VALUE, BRGH = 1, BRG16 = 1
#define BAUDR			115200L			// value of baud rate needed
#define CONSTBR1		CPUCLK * 1000000L
#define CONSTBR2		CONSTBR1 / BAUDR
#define CONSTBR3		CONSTBR2 / 4L
#define BAUDGEN			CONSTBR3 -1
#if (BAUDGEN) > (255L)
	#error Baud rate value not possible with BRDH=1  
#endif
/********** Hardware definitions***********/
#define Rel1 LATC.1
#define Rel2 LATC.2
#define Rel3 LATC.3
/*********** other definitions ************/
#define CA 1.217286E-3
#define CB 1.891450E-4
#define CC 2.006221E-7
#define FactV 5000/4096		// 1.2207
/*  GLOBAL VARIABLES**************/
// interpt
uns16 cntms,ADRes;
bit secflg,msflg,OpsMS,timer1;
uns16 tempoms;
uns16 NbrLoopL,CtrLoopL;
char NbrLoopH,CtrLoopH;

//srl comms
bit NewMsg,MsgComplete,TxDataFlg;
char BufPtrRx,BufPtrTx;
char RData,TData;
char RxBuf[6];
char TxBuf[6];
char svbsr;	
// Process temperature
float24 calc;
float24 CoefA,CoefB,CoefC;
#pragma rambank 1
// storage of analog values
uns16 Bat1,Bat2,Bat3,Bat4;
int16 TempADC,Temp; 
char NextANP;

//other
char SlvState;
uns16 ctr;
char tmradc;
		//bit0:up,1 rdy for com,2 analog valid,3 temp valid,4-6 relays stat

/******* FUNTIONS PROTOTYPES ************/

void main (void);
void CalcDegC (void);
void Init(void);
void InitVar();
void tempo (uns16 durationms,bit locked);
void MainLoop(void);
//void start(void);
void ProcCmd (void);
void ProcADC(void);
// Boot Loader
void bootprocess (void);
void boot_writeflash (uns16 fadr);
bit verif (uns16 fadr);
void boot_outsrl (char outcar);
char boot_waitsrl (void);
void bInitialize(void);
